#include <bits/stdc++.h>
using namespace std;
    
long long cutSize(long long N, long long S) {
    if (S <= N-1) return (S+1)*(S+2)/2;
    if (S >= 2*N-2) { S = 3*N-3-S; return (S+1)*(S+2)/2; }
    long long full_triangle = (S+1)*(S+2)/2;
    long long missing_side = S - (N-1);
    long long missing_area = missing_side * (missing_side+1) / 2;
    return full_triangle - 3*missing_area;
}

void findCell(int N, long long index) {
    // find the correct sum
    int S = 0;
    for (; S<=3*N-3; ++S) {
        long long cs = cutSize(N,S);
        if (cs <= index) index -= cs; else break;
    }
    // find the correct x
    int x = 0;
    for (; x<N; ++x) {
        int remains = S-x;
        if (remains < 0) continue;
        if (remains > 2*N-2) continue;
        long long cs = (remains <= N-1) ? remains+1 : 2*N-1-remains;
        if (cs <= index) index -= cs; else break;
    }
    // find the correct y and z
    for (int y=0; y<N; ++y) {
        int z = S-x-y;
        if (z < 0 || z >= N) continue;
        if (index == 0) {
            cout << x << " " << y << " " << z << "\n";
            return;
        }
        --index;
    }
}

int main() {
    long long a, b, c, q; cin >> a >> b >> c >> q;
    assert( a == b );
    assert( a == c );
    while (q--) {
        long long n; cin >> n;
        --n;
        findCell(a, n);
    }
}
